///// one MAN clock
//// hour flashes ... minutes solid

//##### allowes change led cathodes ... Vcc or ground

#include <Wire.h> //rtc

//clock variables 
byte min = 0;    //0-9
byte min10 = 0;  //0-5
byte hour = 0;   //0-9
byte hour10 = 0; //0-1
byte am     = 0; //dot on for 12 midnight

boolean lite = 0; //digitalWrite 0 low...ground
boolean nolite = 1; //1=high (off...no ground)

 unsigned long oldTime;
 int onhour    = 170;
 int onminutes = 800;
 int offdelay = 300;
 int SWdelay  = 350;

 //##############################################################
 //#######     150 ohm resistors                          #######
 //##############################################################
 //############
 //############  cathode to vcc lite = 0
 //############  cathode to ground lite = 1
 //##############################################################
 //##############################################################
 
 //mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
void setup() {
    //20k pull up. switch to ground 
    pinMode(A0, INPUT_PULLUP); //adj min    0-9
    pinMode(A1, INPUT_PULLUP); //adj min10  0-5
    pinMode(A2, INPUT_PULLUP); //adj hour   0-9
    pinMode(A3, INPUT_PULLUP); //adj hour10 0-2
    for (byte foo=7; foo<14; foo++) {
      pinMode(foo, OUTPUT);
    }
  blank(0);
  
  oldTime=millis();

  Serial.begin(9600);
  Wire.begin(); //RTC

////////////  manual set clock  //////////
////////////  8:14  am
//   hour10=0;
//   hour  =8;   
//   min10 =1;
//   min   =4;
//   updateRTC();

//////////    segment test   /////////////
// for (byte foo=7; foo<14; foo++) {
//  digitalWrite(foo,lite);
//  Serial.println(foo);
//  delay(3000);
//  blank(0);
// }

 
  } //end setup
  
//^^^^^^^^^^^^^^       END of  setup      ^^^^^^^^^^^^
//mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
 
void loop()  { 

readSW();
poleRTC();
convert24to12();


/// display only section ..... no math       
//////////   DISPLAY SCREEN    /////////////

///////////////  hour10
if (hour10>0) {
 for (byte blink=0; blink<5; blink++) {
 displayDig(hour10); 
 delay(onhour);
 blank(10);
  }
}

blank(offdelay);

//////////////  hour
 for (byte blink=0; blink<5; blink++) {
 displayDig(hour);
 delay(onhour);
 blank(10);
  }

blank(offdelay * 1.6); //longer between hr-min

//////////   min10
 displayDig(min10);
 delay(onminutes);
 blank(offdelay);
 
/////////   min
 displayDig(min);
 delay(onminutes);
 blank(offdelay);


   }   //loop end   THE END END END END


///////////////////    functions   /////////////

///////////   blank   all off    ////////////////////////////
void blank(int btime) {  
  for (byte foo=7; foo<=13; foo++) {
    digitalWrite(foo, nolite);
  }
 delay(btime);
} //end blank

//////////  displayDig()   ///////////////////
void displayDig(byte digit) {
  blank(0);
  if (digit==0) {
    digitalWrite(7,lite);
    digitalWrite(8,lite);
    digitalWrite(9,lite);
    digitalWrite(10,lite);
    digitalWrite(11,lite);
    digitalWrite(12,lite);  
  }
    if (digit==1) {
    digitalWrite(8,lite);
    digitalWrite(9,lite);   
  }
    if (digit==2) {
    digitalWrite(7,lite);
    digitalWrite(8,lite);
    digitalWrite(10,lite);
    digitalWrite(11,lite);
    digitalWrite(13,lite);   
  }
    if (digit==3) {
    digitalWrite(7,lite);
    digitalWrite(8,lite);
    digitalWrite(9,lite);
    digitalWrite(10,lite);
    digitalWrite(13,lite);   
  }
    if (digit==4) {
    digitalWrite(8,lite);
    digitalWrite(9,lite);
    digitalWrite(12,lite);
    digitalWrite(13,lite);   
  }
    if (digit==5) {
    digitalWrite(7,lite);
    digitalWrite(9,lite);
    digitalWrite(10,lite);
    digitalWrite(12,lite);
    digitalWrite(13,lite);   
  }
    if (digit==6) {
    digitalWrite(7,lite);
    digitalWrite(9,lite);
    digitalWrite(10,lite);
    digitalWrite(11,lite);
    digitalWrite(12,lite);
    digitalWrite(13,lite);   
  }
    if (digit==7) {
    digitalWrite(7,lite);
    digitalWrite(8,lite);
    digitalWrite(9,lite);   
  }
    if (digit==8) {
    digitalWrite(7,lite);
    digitalWrite(8,lite);
    digitalWrite(9,lite);
    digitalWrite(10,lite);
    digitalWrite(11,lite);
    digitalWrite(12,lite);
    digitalWrite(13,lite);   
  }
    if (digit==9) {
    digitalWrite(7,lite);
    digitalWrite(8,lite);
    digitalWrite(9,lite);
    digitalWrite(10,lite);
    digitalWrite(12,lite);
    digitalWrite(13,lite);   
  }
} //end displayDig() 

////////////////////////   poleRTC()   //////////////
void poleRTC(void) {
 Wire.beginTransmission(0x68); 
 Wire.write(0x01);  //point to min register
 Wire.requestFrom(0x68,2); //2 bits (min,hour)
 byte RTCmin=Wire.read();
 byte RTChour=Wire.read();
 Wire.endTransmission();

 min10=(RTCmin >> 4);  //min10 0-5
 min=(RTCmin & 0xF); //min 0-9
 hour10=((RTChour & 0x30)>>4); //hour10 0-2
 hour=(RTChour & 0xF);  //hour 0-9
 Serial.print(hour10);
  Serial.print(".");
 Serial.print(hour);
  Serial.print(".");
 Serial.print(min10);
  Serial.print(".");
 Serial.println(min);

} //end poleRTC()

///////////////  convert24to12   ///////////////////////////
void convert24to12(void) {
 if (hour10==2) {
  if (hour==0) { hour10=0; hour=8; } //8 pm
  if (hour==1) { hour10=0; hour=9; } //9 pm
  if (hour==2) { hour10=1; hour=0; } //10 pm
  if (hour==3) { hour10=1; hour=1; } //11 pm
 }
 if (hour10==1) { 
  if (hour==2) { am=0; } // 12noon pm
  if (hour>=3) { hour10=0; hour=hour-2; } //1-9 pm
 }
 if (hour10==0 && hour==0) { //12midnight am
  hour10=1; 
  hour=2;
  am=1; 
  }
} //end convert24to12

///////  update RTC with 24hour time 1800=6:00pm (add 12)
void updateRTC(void) {
 Wire.beginTransmission(0x68); 
 Wire.write(0x00);  //point to seconds register
 Wire.write(0x00);  //reset seconds to zero
 Wire.write((min10<<4)+min);
 Wire.write((hour10<<4)+hour);
 Wire.endTransmission(); 
} //end updateRTC

///////////////  readSW()  /////////////////////////////////
void readSW(void) {
//// no sw pressed return (all high=4)
int SWid = digitalRead(A0) + digitalRead(A1) +
      digitalRead(A2) + digitalRead(A3);
  if (SWid!=3) { return; }
      
oldTime=millis();
      
while (millis()-oldTime < 4000) {  

  if (digitalRead(A0)==0) {  
  min++;
  if (min>9) { min=0; }
 displayDig(min);
 delay(SWdelay);
 oldTime=millis();
 }

  if (digitalRead(A1)==0) {
  min10++;
  if (min10>5) { min10=0; }
 displayDig(min10);
 delay(SWdelay);
 oldTime=millis();
 }

  if (digitalRead(A2)==0) {
  hour++;
  if (hour>9) { hour=0; }
 displayDig(hour);
 delay(SWdelay);
 oldTime=millis();
 }

  if (digitalRead(A3)==0) {
  hour10++;
  if (hour10>2) { hour10=0; }
 displayDig(hour10);
 delay(SWdelay);
 oldTime=millis();
 }

 
} //end while
  
  updateRTC();
 
} //end readSW() 
